#!/bin/sh

FN="gettiles"
DIR="osm"

# 2 sec timeout, 2 retrys
WGETCMDBASE="wget -q "

OSMSERVERS="\
             http://c.tile.openstreetmap.org \
             http://osm.oe2xzr.ampr.at/osm/tiles \
             http://b.tile.openstreetmap.org \
             http://a.tile.openstreetmap.org \
             http://a.www.toolserver.org/tiles/osm \
             http://b.www.toolserver.org/tiles/osm \
            "
#--------------------------------------------------------------------------------------------------
if [ -d $DIR ] ; then
  # search zero-size files and destroy them
  #echo -n "cleanup zero-files ... "  
  #find $DIR/tiles -size 0 -delete  
  #echo "done."
  while true; do
	if [ -r $FN ] ; then
		sleep 1
		while read  mapa mapb mapc mapd ; do
        	if ! [ -d $DIR/$mapa/$mapb/$mapc ] ; then
				mkdir $DIR/$mapa/$mapb/$mapc
        	fi
			MAPFILE=$DIR/$mapa/$mapb/$mapc/$mapd.png
			echo "loading tile: $MAPFILE ..."
			for OSMSERVER in $OSMSERVERS ; do
				echo -n "-> from $OSMSERVER - "
				$WGETCMDBASE -O $MAPFILE "$OSMSERVER/$mapb/$mapc/$mapd.png"
				if [ -s $MAPFILE ] ; then
					echo "done."
					break
				else
#					rm $MAPFILE
#					echo -n "zero file, using alternative url - "
#					$WGETCMDBASE -O $MAPFILE "$OSMSERVER/$mapa/$mapb/$mapc/$mapd.png"
#					if [ -s $MAPFILE ] ; then
#						echo "done."
#						break
#					else
						rm $MAPFILE
						echo "zero file, trying next mirror."
#					fi
				fi
			done
		done < $FN
		rm -f $FN
    fi
    sleep 1
  done
else
  echo directory $DIR not found
fi

